/* ATTENTION CET EXEMPLE UTILISE LE SYSTEME DE DEPLACEMENT SIMPLE
 * POUR VOIR COMMENT FONCTIONNE LE PLUS EVOLUE VOIR LE FICHIER trajectoire.c
 */

#include <stdio.h>
#include <string.h>
#include "kuka_api.h"

int main(int argc, char *argv[])
{
  int erreur;
  kukaVar_t *kukaError;
  kukaVar_t cible={"CIBLE",{KUKA_FRAME,{0}}};
  /* Remarque : nous aurions aussi bien pu dclarer cible 
   * comme une variable de type KUKA_POS.
   */


  if (argc != 2) {
    fprintf(stderr, "Usage : %s host\n",argv[0]);
    return 1;
  }

  /*-------------------------------------------------*/
  printf("Dbut des tests.\n");


  /*-------------------------------------------------*/
  printf("Test de la fonction qui rcupre le pointeur sur les erreurs.\n");
  kuka_getError(&kukaError);
  kuka_displayVar( kukaError );

  /*-------------------------------------------------*/
  printf("Test de la fonction d'initialisation.\n");
  printf("\t kuka_initialize(%s)...",argv[1]);
  erreur = kuka_initialize(argv[1]);
  if( erreur ){
    printf("failed\n");
    kuka_displayVar( kukaError );
    return 1;
  }
  printf("succeeded\n");
  printf("Press [enter] to continue\n");
  getchar();

  /*-------------------------------------------------*/
  printf("Test de la fonction getVar.\n");
  printf("\t kuka_getVar()...");
  erreur=kuka_getVar(&cible);
  if( erreur ){
    printf("failed\n");
    kuka_displayVar( kukaError );
    return 1;
  }
  printf("succeeded\n");
  kuka_displayVar(&cible);

  printf("Press [enter] to continue\n");
  getchar();


  /*-------------------------------------------------*/
  printf("Test de la fonction setVar.\n");  
  printf("\t kuka_setVar()...");
  cible.valeur.kukaVal_u.kukaPos.z += 100;
  erreur=kuka_setVar(&cible);
  if( erreur ){
    printf("failed\n");
    kuka_displayVar( kukaError );
    return 1;
  }
  else{
    erreur=kuka_getVar(&cible);
    if( erreur ){
      kuka_displayVar( kukaError );
      return 1;
    }
  }
  printf("succeeded\n");
  kuka_displayVar(&cible);
  
  printf("Press [enter] to continue\n");
  getchar();
  
  /*-------------------------------------------------*/
  printf("Test de la fonction de dsinitialisation.\n");  
  printf("\t kuka_uninitialize()...");
  erreur=kuka_uninitialize();
  if( erreur ){
    printf("failed\n");
    kuka_displayVar( kukaError );
    return 1;
  }
  printf("succeeded\n");

  /*-------------------------------------------------*/
  printf("\nFin du test.\nTODO : tester tous les types.\n");
  printf("Press [enter] to exit.\n");
  getchar();

  return 0;
}

